<template>
  <div class="index-container">
    <ion-header>
      <ion-toolbar color="primary" style="padding: 0 15px">
        <div class="header-content" dir="rtl">
          <img src="/Images/tabs/arrow-right.svg" alt="ion" @click="back" />
          <span class="header-title"> افزودن عضو </span>
        </div>
      </ion-toolbar>
    </ion-header>

    <div class="group-member-container" dir="rtl">
      <span v-if="groupMembersClientList.length === 0">
        {{ $t('tabs.message.selectmembergroup') }}
      </span>
      <groupMemberChip
        class="animation"
        v-for="member in groupMembersClientList"
        :name="member.name"
        :avatar="member.firstChar"
        v-else
        style="margin: 5px"
      />
    </div>

    <div dir="rtl" class="contact-list">
      <ContactsList
        :list="filterByCurrentMemberGroup"
        :hasSearch="false"
      ></ContactsList>
    </div>

    <div dir="rtl">
      <ion-fab
        style="margin: 20px 10px"
        slot="fixed"
        vertical="bottom"
        horizontal="end"
        v-once
      >
        <ion-fab-button @click="addMembersToCurrentGroup" dir="rtl">
          <img src="/Images/tabs/arrow-left.svg" alt="icon" />
        </ion-fab-button>
      </ion-fab>
    </div>
  </div>
</template>

<script setup>
import { defineAsyncComponent } from 'vue';
import { useGroupChat } from '@/store/chats/groupChat.js';
import groupMemberChip from '@/components/message/groupMemberChip.vue';
import { useNestedModals } from '@/store/nestedModals/nestedModals.js';
import {
  IonPage,
  modalController,
  IonHeader,
  IonToolbar,
  IonContent,
  IonFab,
  IonFabButton,
} from '@ionic/vue';
import { computed, onMounted } from 'vue';
import { useOverallChatsStore } from '@/store/chats/overall.js';

const ContactsList = defineAsyncComponent(() =>
  import('@/components/message/contactList.vue'),
);

const overallChatsStore = useOverallChatsStore();
const nestedModals = useNestedModals();
const groupChatStore = useGroupChat();

const filterByCurrentMemberGroup = computed(() => {
  return groupChatStore.memberForAddToCurrentGroup;
});

const groupMembersClientList = computed(() => {
  return overallChatsStore.groupMembersClient;
});

const back = () => {
  overallChatsStore.clearGroupMembersClient();
  nestedModals.closeAddMemberGroup();
  nestedModals.closeMessageDeatailModal();
};

const addMembersToCurrentGroup = async () => {
  groupChatStore.addMemberToCurrentGroup().then((res) => {
    modalController.dismiss();
  });
};

onMounted(() => {
  groupChatStore.filterByCurrentGroupMember();
});
</script>

<style scoped>
.index-container {
  height: 100vh;
  overflow: hidden;
}
.contact-list {
  padding-left: 10px;
  padding-right: 10px;
  padding-top: 10px;
  padding-bottom: 40px;
  height: 90vh;
  overflow-y: scroll;
}
.header-content {
  display: flex;
  align-items: center;
}
.group-member-container {
  width: 100%;
  max-height: 200px;
  overflow-x: scroll;
  display: flex;
  flex-wrap: wrap;
  padding: 15px 15px;
  border-bottom: 1px solid #d3d3d3;
}
.group-member-container span {
  color: #888888;
  font-size: 12px;
  font-style: normal;
  font-weight: 600;
  line-height: normal;
}

ion-toolbar {
  --min-height: 10vh;
  --max-height: 95px;
}
.toolbar-title {
  font-size: 32px;
}

.header-title {
  color: #fff;
  font-size: 25px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
  padding: 0 10px;
}

.item {
  display: flex;
  margin-top: 10px;
}
.item span {
  font-size: 20px;
  font-style: normal;
  font-weight: 500;
  line-height: normal;
  padding: 0 12px;
}

.animation {
  animation: 0.8s animation;
}

@keyframes animation {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}
</style>
